---
title: Node.cloneNode()
slug: Web/API/Node/cloneNode
tags:
  - API
  - DOM
  - DOM Reference
  - Method
  - NeedsBrowserCompatibility
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>Node.cloneNode()</code></strong> method returns a duplicate of the node on which this method was called.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <var>newClone</var> = <var>node</var>.cloneNode([<var>deep</var>])
</pre>

<dl>
 <dt><code><var>node</var></code></dt>
 <dd>The node to be cloned.</dd>
 <dt><code><var>newClone</var></code></dt>
 <dd>
 <p>The new node, cloned from <code><var>node</var></code>.</p>

 <p>The <code><var>newClone</var></code> has no parent and is not part of the document, <em>until</em> it is added to another node that is part of the document (using {{domxref("Node.appendChild()")}} or a similar method). </p>
 </dd>
 <dt><code><var>deep</var></code> {{optional_inline}}<strong><sup>*</sup></strong></dt>
 <dd>
 <p>If <code>true</code>, then <code><var>node</var></code> and its whole subtree—including text that may be in child {{domxref("Text")}} nodes—is also copied.</p>

 <p>If <code>false</code>, only <code><var>node</var></code> will be cloned. Any text that <code><var>node</var></code> contains is not cloned, either (since text is contained by one or more child {{domxref("Text")}} nodes).</p>

 <p><code><var>deep</var></code> has no effect on empty elements (such as the {{HTMLElement("img")}} and {{HTMLElement("input")}} elements).</p>

 <div class="note">
 <p><strong><sup>*</sup>Note:</strong> In the DOM4 specification (since Gecko 13.0 {{geckoRelease(13)}}), the optional <code><var>deep</var></code> argument defaults to <code>true</code>. </p>

 <p><strong>This behavior has been changed in the latest spec!</strong> Although <code><var>deep</var></code> it still optional, it now defaults to <code>false</code>.</p>

 <p><strong>You should <em>always </em>provide an explicit value for backward and forward compatibility.</strong></p>

 <ul>
  <li>With Gecko 28.0 {{geckoRelease(28)}}), the console warned developers not to omit the argument.</li>
  <li>Starting with Gecko 29.0 {{geckoRelease(29)}}), a shallow clone is defaulted instead of a deep clone.</li>
 </ul>
 </div>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">let p = document.getElementById("para1")
let p_prime = p.cloneNode(true)
</pre>

<h2 id="Notes">Notes</h2>

<p id="not-event-listeners">Cloning a node copies all of its attributes and their values, including intrinsic (inline) listeners. It does <em>not</em> copy event listeners added using <a href="/en-US/docs/DOM/element.addEventListener"><code>addEventListener()</code></a> or those assigned to element properties (e.g., <code><var>node</var>.onclick = <var>someFunction</var></code>). Additionally, for a {{HTMLElement("canvas")}} element, the painted image is not copied.</p>

<div class="warning">
<p><strong>Warning:</strong> <code>cloneNode()</code> may lead to duplicate element IDs in a document!</p>

<p>If the original node has an {{domxref("Element/id", "id attribute")}}, and the clone will be placed in the same document, then you should modify the clone's ID to be unique.</p>

<p>{{domxref("Element/name", "Name")}} attributes may need to be modified also, depending on whether duplicate names are expected.</p>
</div>

<p>To clone a node to insert into a <em>different</em> document, use {{domxref("Document.importNode()")}} instead.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-node-clonenode", "Node.cloneNode()")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 Core", "core.html#ID-3A0ED0A4", "Node.cloneNode()")}}</td>
   <td>{{Spec2("DOM3 Core")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 Core", "core.html#ID-3A0ED0A4", "Node.cloneNode()")}}</td>
   <td>{{Spec2("DOM2 Core")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Node.cloneNode")}}</p>
</div>
